(in-package :om)
;;;;;;;;;;;;;;;;;;;;;;;abs-proportions;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defun abs-props (liste)
(if (null liste)
       liste
       (let* ((first (car liste))
              (rest (rest liste))
              )
         (if (numberp first)
           (cons (+ first (loop while  (floatp (first rest))
                                sum (round (pop rest))))
                 (abs-props rest))
           (cons (abs-props first) (abs-props rest))))))

(om::defmethod! absolute-props ((tree list))
   :initvals '(? ((4//4 (1 (1 (1 2 1 1)) 1 1)) (4//4 (1 (1 (1 2 1 1)) -1 1))))
   :indoc '("tree")
   :icon 134
   :doc "groups any propo such as 4 1.0 into 5
and 8 1.0 into 9 for absolute proportional
manipulation like for instance in recursive tree proportion rotations.
-reducetree has the same effect-"

   (let* ((liste (resolve-? tree)))
     (abs-props liste)
     ))

